// ActorModification.h: interface for the ActorModification class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ACTORMODIFICATION_H)
#define AFX_ACTORMODIFICATION_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <deque>

namespace ucf
{

template <typename TModification>
class ActorModification  
{
public:
	typedef std::deque<TModification*> tModifications;


	ActorModification();

	~ActorModification();

	void RegisterModification(TModification* modification);
	void GetModification(tModifications*& modifications) const;

private:
	tModifications* fModifications;
};

//////////////////////////////////////////////////////////////////////
// inlines
//////////////////////////////////////////////////////////////////////

template <typename TModification>
ActorModification<TModification>::ActorModification()
	:fModifications(new tModifications() )
{
}

template <typename TModification>
ActorModification<TModification>::~ActorModification()
{
	tModifications::iterator iterMod = fModifications->begin();
	while (iterMod != fModifications->end())
	{
		TModification* modification = *iterMod;
		delete modification;
		++iterMod;
	}

	delete fModifications;
}

template <typename TModification>
void ActorModification<TModification>::RegisterModification(TModification* modification)
{
	fModifications->insert(fModifications->end(), modification);
}

template <typename TModification>
void ActorModification<TModification>::GetModification(tModifications*& modifications) const
{

	modifications = fModifications;
	((ActorModification<TModification>*)this)->fModifications = new tModifications();
}

} // namespace

#endif // !defined(AFX_ACTORMODIFICATION_H)
